//
//     Copyright (C) 2003 - 2008 Sophia Cradle Incorporated
//     All rights reserved.
//
//     File: ContentWindow.cpp
//

#include "ContentWindow.hpp"
#include "cartoon_sfy_frame.hpp"

// RXgN^
ContentWindow::ContentWindow() static_throws
{
}

// fXgN^
ContentWindow::~ContentWindow()
{
}

// NewInstance() ֐
ContentWindowSmp ContentWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<ContentWindow>(Factory(::new ContentWindow, exception));
}

// \y[Wԍ̐ݒ
Void ContentWindow::SetPage(SIntN n)
{
    page = n;
    Invalidate();  // ĕ`̈̓o^(y[Wԍݒ肳ꂽƂ͍ĕ`悷)
}

// rbg}bvRec̕`
Void ContentWindow::DrawImage(SFXGraphicsPtr graphics) const
{
    SFBBitmapSmp        pSourceBitmap;          // gOrbg}bv
    SFBTransformSmp     pTransform;             // ITransform C^[tF[X
    AEETransformMatrix  matrix;                 // rbg}bvό`ps
    AEEBitmapInfo       bmpinfo;                // rbg}bvɊւ

    SFXGrid             transfered_point;       // ]̍̍W
    SFXSize             region_size;            // rbg}bv\̈̃TCY
    SFXSize             bitmap_size;            // gOrbg}bṽTCY
    Float64             expansion_ratio;        // rbg}bv̊g嗦
    Float64             bmp_aspect_ratio;       // rbg}bv̏c
    Float64             region_aspect_ratio;    // ̈̏c

    // \[Xt@Crbg}bv[h
    SFBShellSmp         shell = SFBShell::GetInstance();
    SFBBitmapSmp        bitmap = shell->LoadResBitmap(CARTOON_SFY_FRAME_RES_FILE, IDI_PICT1 + page - 1);

    // rbg}bv̊g嗦vZ
    bitmap->GetInfo(&bmpinfo);
    bitmap_size.SetWidth(static_cast<SInt16>(bmpinfo.cx));
    bitmap_size.SetHeight(static_cast<SInt16>(bmpinfo.cy));

    region_size=GetLocalBound().GetSize();

    bmp_aspect_ratio = static_cast<Float64>(bitmap_size.GetWidth()) / static_cast<Float64>(bitmap_size.GetHeight());
    region_aspect_ratio = static_cast<Float64>(region_size.GetWidth()) / static_cast<Float64>(region_size.GetHeight());

    Bool isheight_fit;
    if (region_aspect_ratio >= bmp_aspect_ratio) {
        // RecEBhȄc䂪rbg}bv̏ꍇ
        expansion_ratio = static_cast<Float64>(region_size.GetHeight() / bitmap_size.GetHeight());
        isheight_fit = true; // Rec̈̏ctɉ摜g傷
    }
    else {
        // RecEBhȄc䂪rbg}bvc̏ꍇ
        expansion_ratio = static_cast<Float64>(region_size.GetWidth()) / static_cast<Float64>(bitmap_size.GetWidth());
        isheight_fit = false; // Rec̈̉tɉ摜g傷
    }

    // GetGlobalBound() ֐𗘗pĉʂ̐΍Wnŗ̈̊Jn_̍W擾
    // rbg}bv̓]WvZ
    transfered_point.SetX(static_cast<SInt16>(bitmap_size.GetWidth() * (expansion_ratio - 1.0) / 2.0  +  GetGlobalBound().GetOrigin().GetX()));
    transfered_point.SetY(static_cast<SInt16>(bitmap_size.GetHeight() * (expansion_ratio - 1.0) / 2.0 +  GetGlobalBound().GetOrigin().GetY()));

    if (isheight_fit) {
        transfered_point.AddX(static_cast<SInt16>((region_size.GetWidth() - bitmap_size.GetWidth() * expansion_ratio) / 2.0));
    }
    else {
        transfered_point.AddY(static_cast<SInt16>((region_size.GetHeight() - bitmap_size.GetHeight() * expansion_ratio) / 2.0));
    }


    // ό`psɒlݒ肷
    // ڍ : BREW t@X́uAEEMatrixTransformv
    matrix.A = static_cast<SIntN>(expansion_ratio * 256.0);
    matrix.B = 0;
    matrix.C = 0;
    matrix.D = static_cast<SIntN>(expansion_ratio * 256.0);

    // rbg}bvg債ăRecEBhEɕ`悷

    // ڍ : BREW t@X́uIBITMAP_BltIn()v
    pSourceBitmap = graphics->CreateBitmap(bitmap_size);
    pSourceBitmap->BltIn(SFXRectangle(0, 0, bitmap_size),
                         bitmap,
                         SFXGrid(0, 0));

    // ڍ : BREW t@X́uITransformvсuITRANSFORM_TransformBltComplex()v
    pTransform = SFBTransform::NewInstance(graphics->GetDestination());
    pTransform->TransformBltComplex(SFXGrid(transfered_point.GetX(), transfered_point.GetY()),
                                    pSourceBitmap,
                                    SFXRectangle(0, 0, bitmap_size),
                                    matrix);
}

// eLXgRec̕`
Void ContentWindow::DrawText(SFXGraphicsPtr graphics, SFXPathConstRef path, UInt16 id) const
{
    SFBShellSmp shell = SFBShell::GetInstance();

    // \[Xt@CeLXg[hăRecEBhE̒ɕ`悷
    graphics->DrawSingleText(shell->LoadResString(path.Get(), id),
                             GetLocalBound(),
                             BLACK_COLOR);
}

// `nh : HandleRenderRequest() z֐I[o[Ch
Void ContentWindow::HandleRenderRequest(SFXGraphicsPtr graphics) const
{
    if ( page == 0 ) {
        // JnbZ[W("͂܂")`悷
        DrawText(graphics, TEXT_START);
    } else if ( 0 < page && page <= PICTS_NUMBER ) {
        // page ɐݒ肳ꂽԍ̃rbg}bv`悷
        DrawImage(graphics);
    } else {
        // IbZ[W("܂")`悷
        DrawText(graphics, TEXT_END);
    }
}
